package com.github.huangp.learning.ga.travellingsalemanproblem;

public interface GeneticAlgorithm<T extends Individual<T>, P extends Population<T>> {
    P evolvePopulation(P oldPopulation);

    T crossover(T one, T other);

    T mutate(T target);

    T selectFittestFromSample(Population<T> oldPopulation);
}
